<?php
# This file is distributed under GNU GPLv1 and further versions.
# This file was written by Zdenek Styblik
# This file is part of weathermap4rrd-ng
#
# Zdenek Styblik
# e-mail: zdenek <dot> styblik <at> gmail <dot> com
#
# Last update: 2008-07-17
#
class editor extends defaultLib {
	public $decx;
	public $decy;
	public $jsarray;
	public $scriptname;
	public $settings;
	// init
	function __construct() {
		# these values are used for altering nodes position
		# regarding to menu's height.
		$this->settings = new StdClass;
		$settings = $this->settings;
		$this->decx = 0;
		$this->decy = 100;
		$settings->config = new StdClass;
		$settings->xmlobject = new StdClass;
		$settings->layout = "editor.xsl";
		$this->scriptname = $this->getScriptname();
		$settings->xmlobject->scriptname = $this->scriptname;
	}
	// clean-up
	function __destruct() {
		unset($this->settings);
	}
	// go!
	public function init() {
		if (isset($_GET['action'])) {
			$action = $this->stripMe($_GET['action']);
		} else {
			$action = "foo";
		}
		switch ($action) {
			case 'save':
				$this->savemap();
				$this->indexpage();
				break;
			case 'revert':
				$this->revert();
				$this->indexpage();
				break;
			case 'index':
				$this->indexpage();
			default:
				$this->indexpage();
				break;
		}
	}
	private function savemap() {
		$path = $this->getPath();
		$config = $this->settings->config;
		$xml = $this->settings->xmlobject;
		require_once("{$path}lib/configfile.php");
		$configfile = new config_file();
		if ($configfile->readconfig() == false) {
			# error
			throw new Exception ("Unable to read weathermap.xml. Check permissions.");
		} else {
			# create backup(revert) file
			$cfg = "weathermap.xml";
			if (file_exists($cfg)) {
				copy ($cfg, $cfg . ".1");
			}
			$config = $configfile->getConfig();
			# get and replace title position
			$getX = "Xtitle";
			$getY = "Ytitle";
			if (isset($_POST[$getX]) && is_numeric($_POST[$getX])) {
				$config->title->x = $this->stripMe($_POST[$getX]) - $this->decx;
			}
			if (isset($_POST[$getY]) && is_numeric($_POST[$getY])) {
				$config->title->y = $this->stripMe($_POST[$getY]) - $this->decy;
			}
			# get and replace legend position
			$getX = "Xlegend";
			$getY = "Ylegend";
			if (isset($_POST[$getX]) && is_numeric($_POST[$getX])) {
				$config->legend->x = $this->stripMe($_POST[$getX]) - $this->decx;
			}
			if (isset($_POST[$getY]) && is_numeric($_POST[$getY])) {
				$config->legend->y = $this->stripMe($_POST[$getY]) - $this->decy;
			}
			# get and replace node positions
			if (isset($config->nodes)) {
				foreach ($config->nodes as $node) {
					$getX = "X" . str_replace('-', "Wx4xRxD", $node->name);
					$getY = "Y" . str_replace('-', "Wx4xRxD", $node->name);
					if (isset($_POST[$getX]) && is_numeric($_POST[$getX])) {
						$node->x = abs($this->stripMe($_POST[$getX])) - $this->decx;
					}
					if (isset($_POST[$getY]) && is_numeric($_POST[$getY])) {
						$node->y = abs($this->stripMe($_POST[$getY])) - $this->decy;
					}
				} // foreach $config->nodes
			} // if isset
			# get and reaplace internode positions
			if (isset($config->links)) {
				foreach ($config->links as $link) {
					if (isset($link->internode) && isset($link->inodegroup) && is_numeric($link->inodegroup)) {
						if (is_array($link->internode)) {
							// there is many inodes
							$inodecount = count($link->internode);
							for ($i = 1; $i <= $inodecount; $i++) {
								//$getX = "X" . str_replace('-', "Wx4xRxD", $link->group) . $i;
								//$getY = "Y" . str_replace('-', "Wx4xRxD", $link->group) . $i;
								$getX = "XA{$link->inodegroup}B{$i}";
								$getY = "YA{$link->inodegroup}B{$i}";
								if (isset($_POST[$getX]) && is_numeric($_POST[$getX])) {
									$link->internode[$i]->x = abs($this->stripMe($_POST[$getX])) - $this->decx;
								}
								if (isset($_POST[$getY]) && is_numeric($_POST[$getY])) {
									$link->internode[$i]->y = abs($this->stripMe($_POST[$getY])) - $this->decy;
								}
							}
						} else {
							# do nothing; this should never happen
							$this->auto_index++;
							$settings->debug->entry[$this->auto_index] = new StdClass;
							$settings->debug->entry[$this->auto_index] = "Unexpected error #01 - index.php";
						}
					} // if isset($link->internode ....
				} // foreach $config->links
			} // if isset
		} // if $configfile->readconfig() == false
		if (isset($config->debug))
			unset($config->debug);
		$xml = "<root>\n";
		$xml.= $this->objToXML($config);
		$xml.= "</root>";
		$configfile->writeconfig($xml);
		header("Location: {$this->scriptname}?module=editor");
		exit();
	}
	private function indexpage() {
		$config = $this->settings->config;
		$xml = $this->settings->xmlobject;
		require_once('lib/configfile.php');
		$configfile = new config_file();
		if ($configfile->readconfig() == false) {
			# error
			# no config file exists, but we're going
			# to give user create one, hm? :)
			$config = $configfile->getDefaultConfig();
			# save xml
			$xml2save = "<root>\n";
			$xml2save.= $this->objToXML($config);
			$xml2save.= "</root>";
			$configfile->writeconfig($xml2save);
			$xml->width = $config->width;
			$xml->height = $config->height;
			$xml->debugtop = $config->height + $this->decy + 20;
		} else {
			$config = $configfile->getConfig();
		}
		# Gets size of background, if set
		if (isset($config->background) && file_exists($config->background)) {
			$im = @imagecreatefrompng($config->background);
			$width = imagesx($im);
			$height = imagesy($im);
			imagedestroy($im);
			$sizefrombg = 1;
		} else {
			$width = $config->width;
			$height = $config->height;
		}
		# Load JS script template
		# part of ugly workaround
		# see appendToJS
		#
		# JS Init()
		$this->jsarray = array();
		$this->jsarray["switches"] = "";
		$this->jsarray["images"] = "";
		$this->jsarray["count"] = 0;
		$xml->objects = new StdClass;
		$xml->nodes = new StdClass;
		$xml->links = new StdClass;
		$xml->debugtop = $config->height + $this->decy + 20;
		#$xml->debugleft = "";
		# Redefine Legend position
		# note: i don't know why, but add +1px to legend X and Y position
		$this->addObject("legend", $config->legend->x+1, $config->legend->y+1, "legend", 
			"http://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']) . "/legend.php");
		$this->appendToJS("legend", $config->legend->x+1, $config->legend->y+1);
		# Redefine Title position
		# note: i don't know why, but add +1px to title X position
		$this->addObject($config->title->text, $config->title->x+1, $config->title->y, "title",
			"http://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']) . "/title.php");
		$this->appendToJS("title", $config->title->x+1, $config->title->y);
		if (isset($config->nodes)) {
			# Redefine nodes
			foreach ($config->nodes as $node) {
				$id = str_replace('-', "Wx4xRxD", $node->name);
				$pix_width = imagefontwidth($config->font) * strlen($node->label);
				$pix_height = imagefontheight($config->font);
				$decalagex = floor($pix_width/2) + 3 + (strlen($node->label) % 2);
				$decalagey = floor($pix_height/2);
				$this->addObject($node->label, $node->x-$decalagex, $node->y-$decalagey, $id, 
					"http://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']) . "/label.php?text={$node->label}&#38;font={$config->font}");
				$this->addNodeToSelect($node->label, $node->name);
				$this->appendToJS($id, $node->x+$decalagex, $node->y+$decalagey);
			}
		} // if isset $config->nodes
		if (isset($config->links)) {
			# Note: internode gets + 8 to X and Y position
			foreach ($config->links as $link) {
				$this->addLinkToSelect($link->name);
				if (isset($link->internode) && is_array($link->internode) && isset($link->inodegroup) && is_numeric($link->inodegroup)) {
					$j = count($link->internode);
					for ($i = 1; $i <= $j; $i++) {
						// there is probably only one internode
						$id = $link->inodegroup;
						$pix_width = imagefontwidth($config->font) * strlen($i);
						$pix_height = imagefontheight($config->font);
						$decalagex = floor($pix_width/2) + 3 + (strlen($i) % 2);
						$decalagey = floor($pix_height/2);
						$text = $i-1;
						$this->addObject("A{$id}B{$i}", $link->internode[$i]->x-$decalagex, $link->internode[$i]->y-$decalagey,
						 	"A{$id}B{$i}", "http://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']) . "/internode.php?text={$text}");
						$this->appendToJS("A{$id}B{$i}", $link->internode[$i]->x-$decalagex, $link->internode[$i]->y-$decalagey);
					}
				} else {
							# dummy
				}
			}
		} // if isset $config->links
		# invoke writing js positioning file
		$this->writeJSPosFile();
		// HTTP/1.1
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("Cache-Control: post-check=0, pre-check=0", false);
		// HTTP/1.0
		header("Pragma: no-cache");
	}
	private function revert() {
		$cfg = "weathermap.xml";
		if (file_exists("{$cfg}.1") && is_readable("{$cfg}.1")) {
			copy ("{$cfg}.1", $cfg);
		}
		header("Location: {$this->scriptname}?module=editor");
		exit();
	}
	# Ugly workaround for js file which is needed for Drag 'n Drop
	# label: string;
	# posx: integer;
	# posy: integer;
	# id: string;
	# src: string;
	private function addObject($label = "foo", $posx = 0, $posy = 0, $id = "zeroid", $src = "foo") {
		# todo: check input
		$xml = $this->settings->xmlobject->objects;
		$this->auto_index++;
		$xml->entry[$this->auto_index] = new StdClass;
		$xml->entry[$this->auto_index]->label = $label;
		$xml->entry[$this->auto_index]->posx = $posx + $this->decx;
		$xml->entry[$this->auto_index]->posy = $posy + $this->decy;
		$xml->entry[$this->auto_index]->id = $id;
		$xml->entry[$this->auto_index]->src = $src;
	}
	
	# adds node into drop-down menu
	# label: string;
	# node: string;
	private function addNodeToSelect($label = "foo", $node = "bar") {
		# todo: check input
		$this->auto_index++;
		$xml = $this->settings->xmlobject->nodes;
		$xml->entry[$this->auto_index] = new StdClass;
		$xml->entry[$this->auto_index]->name = $label;
		$xml->entry[$this->auto_index]->value = $node;
	}

	# adds link into drop down menu
	# label: string;
	private function addLinkToSelect($label = "foo") {
		# todo: check input
		$this->auto_index++;
		$xml = $this->settings->xmlobject->links;
		$xml->entry[$this->auto_index] = new StdClass;
		$xml->entry[$this->auto_index]->name = $label;
	}
	
	# Ugly workaround for js file which is needed for Drag 'n Drop
	# id: string;
	# posx: integer;
	# posy: integer;
	private function appendToJS($id = NULL, $posx = NULL, $posy = NULL) {
		# todo: check input
		$line = "\t\tcase \"{$id}\":\n";
		$line.= "\t\t\tdocument.myform.{$id}.value = dd.obj.name;\n";
		#$line.= "\t\t\tdocument.myform.X{$id}.value = dd.obj.x-{$posx};\n";
		#$line.= "\t\t\tdocument.myform.Y{$id}.value = dd.obj.y-{$posy};\n";
		$line.= "\t\t\tdocument.myform.X{$id}.value = dd.obj.x;\n";
		$line.= "\t\t\tdocument.myform.Y{$id}.value = dd.obj.y;\n";
		$line.= "\t\t\tbreak;\n";
		$line.= "\t\t\t//\n";
		$this->jsarray["switches"].= $line;
		$this->jsarray["images"].= " \"{$id}\",";
		$this->jsarray["count"] = $this->jsarray["count"] + 1;
	}

	private function writeJSPosFile() {
		# get js template
		$string = file_get_contents('xsl/js/positioning.js');
		# strip down the last ','
		$this->jsarray["images"] = substr($this->jsarray["images"], 0, -1);
		# count+1
		# replace {tags} with values
		$string = $this->replacer($string, $this->jsarray);
		# write js file
		$handle = fopen('positioning.js', "w+") or die("Unable to write positioning.js which is required
		 	by drag-n-drop. Please, check permissions for this file. Terminated.");
		fwrite($handle, $string);
		fclose($handle);
	}
}
?>
